unit ufmpaper;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ImgList, ComCtrls, ExtCtrls, DB, DBTables, DBCtrls, Grids,
  DBGrids,  StdCtrls, Mask,shellapi,
   ActnList, ADODB;

type
  tp=record
    kind:string;
    level:integer;
    name:string;
    id:variant;
    pid:variant;
    caption:string;
    mark:integer;
  end;
  pn=^tp;

  Tfmpaper = class(Tform)
    ImageList1: TImageList;
    Panel1: TPanel;
    tv: TTreeView;
    DataSource1: TDataSource;
    DataSource2: TDataSource;
    DBGrid1: TDBGrid;
    DataSource3: TDataSource;
    OpenDialog1: TOpenDialog;
    DataSource4: TDataSource;
    Splitter1: TSplitter;
    ScrollBox1: TScrollBox;
    dt311: TScrollBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label5: TLabel;
    ed1: TDBEdit;
    ed2: TDBEdit;
    ed4: TDBLookupComboBox;
    ed7: TDBMemo;
    Splitter2: TSplitter;
    ActionList1: TActionList;
    acrun: TAction;
    dt1: TADOTable;
    dt2: TADOTable;
    dt3: TADOTable;
    dt4: TADOTable;
    dt1depid: TAutoIncField;
    dt1depname: TWideStringField;
    dt2catid: TAutoIncField;
    dt2depid: TIntegerField;
    dt2catname: TWideStringField;
    dt4filetypeid: TAutoIncField;
    dt4filetypename: TWideStringField;
    dt4exename: TWideStringField;
    dt4ico: TBlobField;
    dt3depid: TIntegerField;
    dt3catid: TIntegerField;
    dt3fileid: TAutoIncField;
    dt3fileno: TWideStringField;
    dt3filename: TWideStringField;
    dt3filememo: TMemoField;
    dt3filetypeid: TIntegerField;
    dt3createday: TDateTimeField;
    dt3editday: TDateTimeField;
    dt3bmp: TBlobField;
    Button1: TButton;
    dt3filepath: TWideStringField;
    Label4: TLabel;
    DBEdit1: TDBEdit;
    Button2: TButton;
    DBNavigator1: TDBNavigator;
    procedure FormCreate(Sender: TObject);
    procedure Table3AfterPost(DataSet: TDataSet);
    procedure Table3AfterDelete(DataSet: TDataSet);
    procedure tvClick(Sender: TObject);
    procedure acrunExecute(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure dt3AfterPost(DataSet: TDataSet);
    procedure dt3AfterDelete(DataSet: TDataSet);
  private
    { Private declarations }
  public
    { Public declarations }
    ix,iy:integer;
    procedure createtv(n:ttreenode=nil);
    procedure readnode;
    procedure opendb;
  end;

var
  fmpaper: Tfmpaper;

implementation

uses udm1;

{$R *.dfm}

Procedure TFMPAPER.opendb;
begin
end;

Procedure TFMPAPER.createtv(n:ttreenode);
var n1,n2,n3,ns:ttreenode;
    p1,p2,p3:pn;
    ps:pn;
    s,i:integer;
    id:string;

  procedure findnode(p:pn;fn:ttreenode);
  begin

      if (p.id=pn(fn.Data)^.id) and
         (p.pid=pn(fn.Data)^.pid) and
         (p.kind=pn(fn.Data)^.kind) 
      then begin
         tv.Select(fn);
         readnode;
         exit;
      end
      else begin
        findnode(p,fn.GetNext);
      end;
  end;
  function addnode(p:pointer;a:string;s:ttreenode):ttreenode;
   var n:ttreenode;
  begin
    n:=ttreenode.create(tv.items);
    n.text:=a;
    tv.Items.AddNode(n,s,a,p,naaddchild);
    result:=n;
  end;
begin
        new(ps);
        ps.id:=0;
        if n<> nil then begin
           ps.kind:=pn(n.Data)^.kind;
           ps.id:=pn(n.Data)^.id;
           ps.pid:=pn(n.Data)^.pid;
        end;

        tv.Items.Clear;
        dt3.DisableControls;

        dt1.open;
        dt2.open;
        dt3.close;
        dt3.open;

        dt1.first;
        while not dt1.Eof do begin
            new(p1);
            p1.level:=1;
            p1.id:=dt1.fieldbyname('depid').asstring;
            p1.name:='dep';
            p1.kind:='dep';
            p1.caption:=dt1.fieldbyname('depname').asstring;
            n1:=addnode( p1,p1.caption,nil );
            n1.SelectedIndex:=n1.ImageIndex;
            dt2.first;
            while not dt2.Eof do begin
              new(p2);
              p2.level:=2;
              p2.id:=dt2.fieldbyname('catid').asstring;
              p2.pid:=p1.id;
              p2.name:='cat';
              p2.kind:='cat';
              p2.caption:=dt2.fieldbyname('catname').asstring;
              n2:=addnode(p2,p2.caption,n1);
              n2.SelectedIndex:=n2.ImageIndex;
              dt3.First;
              while not dt3.Eof do begin
                new(p3);
                p3.level:=3;
                P3.pid:=p2.id;
                P3.ID:=dt3.fieldbyname('fileid').AsString;
                p3.name:='file';
                p3.kind:='file';
                p3.caption:=dt3.fieldbyname('filename').AsString;

                n3:=addnode(p3,p3.caption,n2);
                if dt3.fieldbyname('filetypeid').asinteger=1 then
                begin
                  n3.ImageIndex:=2;
                  n3.SelectedIndex:=2;
                end;
                if dt3.fieldbyname('filetypeid').asinteger=2 then
                begin
                  n3.ImageIndex:=1;
                  n3.SelectedIndex:=1;
                end;

                //dispose(p3);
                dt3.next;
              end;
              //dispose(p2);
              dt2.Next;
            end;
            //dispose(p1);
            dt1.Next;
        end;

        if ps.id <> 0 then
        findnode(ps,tv.TopItem);

        dispose(ps);

        dt3.EnableControls;

end;

procedure Tfmpaper.FormCreate(Sender: TObject);
begin
        inherited;
        createtv(nil);
        dt4.open;
        self.WindowState:=wsmaximized;
end;

procedure Tfmpaper.Table3AfterPost(DataSet: TDataSet);
begin
        createtv(tv.Selected);
end;
procedure Tfmpaper.Table3AfterDelete(DataSet: TDataSet);
begin
        createtv(tv.Selected.GetPrev);
end;


procedure tfmpaper.readnode;
var n:ttreenode;
begin
      n:=tv.Selected;
      if n=nil then exit;
      if pn(n.Data)^.kind='dep' then begin
         dt3.Close;
      end;

      if pn(n.Data)^.kind='cat'  then begin
         dt1.Locate('depid',pn(n.data)^.pid,[loCaseInsensitive]);
         dt2.Locate('catid',pn(n.data)^.id,[loCaseInsensitive]);
         if not dt3.Active then dt3.Open;
      end;
      if pn(n.Data)^.kind='file' then begin
         dt1.Locate('depid',pn(n.parent.data)^.pid,[loCaseInsensitive]);
         dt2.Locate('catid',pn(n.parent.data)^.id,[loCaseInsensitive]);
         if not dt3.Active then dt3.Open;
         dt3.First;
         dt3.Locate('fileid',pn(n.Data)^.id,[locaseinsensitive]);
      end;
end;
procedure Tfmpaper.tvClick(Sender: TObject);
begin
        readnode;
end;


procedure Tfmpaper.acrunExecute(Sender: TObject);
var a,b:string;

procedure myExec(FileName, Parameters, Directory: string);
var
  Operation: string;
begin
  Operation := 'open';
  ShellExecute(Application.Handle, PChar(Operation), PChar(FileName), PChar(Parameters), PChar(Directory),
    SW_SHOWNORMAL);
end;

begin
        if not dt3.Active then exit;
        a:=dt4.FieldByName('exename').asstring;
        b:=dt3.fieldbyname('filepath').asstring;

  ShellExecute(Application.Handle,
               PChar('open'),
               PChar(a),
               PChar(extractfilename(b)),
               PChar(extractfilepath(b)),
               SW_SHOWmaximized);
end;

procedure Tfmpaper.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    action:=cafree;
end;

procedure Tfmpaper.Button1Click(Sender: TObject);
begin
   self.acrun.Execute;
end;

procedure Tfmpaper.Button2Click(Sender: TObject);
begin
  if self.OpenDialog1.Execute then begin
     self.dt3.edit;
     self.dt3filepath.asstring:=self.OpenDialog1.FileName; 
  end;

end;

procedure Tfmpaper.dt3AfterPost(DataSet: TDataSet);
begin
        createtv(tv.Selected);

end;

procedure Tfmpaper.dt3AfterDelete(DataSet: TDataSet);
begin
        createtv(tv.Selected.GetPrev);
end;

initialization
  registerclass(tfmpaper);
finalization
  unregisterclass(tfmpaper);

end.
